clc
clear all
warning off all
global Res;
% --------------------------------------------
% Parameters

Res = [15 20]; % map size, must be 4:3 ratio.
numSubj = 5; % number of subject tested
frameSkip = 10; % frame skip, since each frame theres not much differences

global featurePath;
global savePath;
global gameSubjectSize;

global objects;
global patches;
global probAO;
%%%%%%%%%%init;

fprintf('Vgames3\n');
featurePath = './data/';
gameNo = 1;

fprintf('Running game\n');

% Load single subject data
fprintf('Loading data \n'); tic;
%load([featurePath 'drv_3DDS_fix.mat']);
load([featurePath 'drv_3DDS_sacc.mat']);
clear bumap event eyemap eyepos gist hand
load([featurePath 'drv_3DDS_fix.mat']);
clear bumap
toc

% Group all into one giant map
fprintf('Grouping to cells '); tic;
gameSubjectSize=zeros(1,numSubj);
theMap = cell(3,1); eyePos = []; allhand = [];
for i=1:numSubj
    j=1;
    tmp=frame{i};
    temp=[];
    %tmp=(1:size(frame{i},1));
    %tmp=tmp';
    %tmp=(1:size(event{i},1));
    %tmp = find(hand{i}(:,5)~=0 | hand{i}(:,6)~=0 | hand{i}(:,7)~=0 | hand{i}(:,8)~=0 | hand{i}(:,9)~=0 | hand{i}(:,10)~=0);   %frames where something significant happens
    while(j<=size(tmp,1))
        for k=tmp(j)-2:tmp(j)+2
            if(k>0 && k<=18000)
                temp=[temp;k];
            end
        end
        j=j+1;
    end
    tmp=temp;
    gameSubjectSize(i)=length(tmp);
    eyePos = vertcat(eyePos,downscaleMap(eyemap{i}(tmp,:),Res)); % eye
    theMap{1} = vertcat(theMap{1},hand{i}(tmp,:));               %get the button values
    theMap{2} = vertcat(theMap{2},event{i}(tmp,:));               %get the event happening in the frame
    theMap{3} = vertcat(theMap{3},gist{i}(tmp,:));               %get the gist for regression
end
toc
labelName = { ...
        'MEP'  
        'Rand' 
        'Regression'
        'kNN'
        'DBN'
        };
for i=1:length(labelName)
    fprintf('Model: %s\n',labelName{i});
    eval(['[gameScoresP' labelName{i} '  predictedP' labelName{i} ' eyePositions scoresMeanAUC' labelName{i} '   R' labelName{i} ']   = modelClassifier3DDS(theMap, eyePos,labelName{i});'])
    onlineName = 'online'; 
    save(['./data/Result_3DDS_sacc_' onlineName '_' labelName{i} '.mat'],['gameScoresP' labelName{i}] , ['predictedP' labelName{i}],['scoresMeanAUC' labelName{i}] ,['R' labelName{i}]);
end

