% making a classifier. We start with a simple linear regression for each game
% Make train and test data - If there are n subjects, each time data from
% n-1 subjects are used as training and evaluates over the remainin gone (leave 1 out).

function [gameScores gameScoresSEM predictedPAll predictedObjAll eyePositions gameAUCScores RRR] = modelBaseClassifierAll(games, features, positions, objectsTag, classifierType, history)
global rGauss;
global gameSubjectSize;
global Res;
global theGistCluster;
global objects;
global patches;
global probAO;

gameScores = [];
gameScoresSEM = [];
predictedPAll = [];
predictedObjAll = [];
eyePositions = [];
gameNo = games;

gameAUCScores = [];

if nargin < 6
    history = 0;
end

RRR = cell(1,length(gameSubjectSize)); % Ali


%%% Index making
allIndex = cell(length(gameSubjectSize),1);
for i=1:length(gameSubjectSize)
    startNo=sum(gameSubjectSize(1:i-1));
    allIndex{i} = startNo+1 : startNo+gameSubjectSize(i);
end


%T = features;
P = positions;
T = cell(length(features),1);
for i=1:length(features)
    %     if i==2 % Gist
    %         IDX = clusterPCAkmeans(features{i},theGistCluster);
    %     elseif i==3 % BU
    %         [c IDX] = max(features{i},[],2);
    %     else
    IDX=features{i};
    
    if history > 0
        tmpT = zeros( size(IDX,1), size(IDX,2)*(history+1) );
        tmpT(:,1:size(IDX,2)) = IDX;
        for j=1:length(allIndex)
            for k=1:history
                tmpT(allIndex{j}(k+1:end),(size(IDX,2)*k)+1:(size(IDX,2)*(k+1))) = ...
                    IDX(allIndex{j}(1:end-k),:);
            end
        end
        IDX = tmpT;
    end
    
    
    
    %     end
    T{i} = IDX;
end


% if history > 0
%     tmpP = zeros( size(P,1), size(P,2)*2 );
%     tmpP(:,1:size(P,2)) = P;
%     tmpT = [];
%     for i=1:length(allIndex)
%         tmpP(allIndex{i}(2:end),size(P,2)+1:end) = P(allIndex{i}(1:end-1),:);
%     end
% end
%

% toc
for subj=1:length(gameSubjectSize)
    fprintf('%d%s%d ', gameNo, '-', subj); tic;
    
    
    allsubj = 1:length(gameSubjectSize);
    testIndex = allIndex{subj};
    trainIndex = horzcat(allIndex{allsubj~=subj});
    %%% Done Index making
    TrainP = (double(P(trainIndex,:)));
    TestP = (double(P(testIndex,:)));
    
    
    TrainT = cell(length(features),1);
    TestT  = cell(length(features),1);
    for i=1:length(features)
        TrainT{i}= T{i}(trainIndex,:);
        TestT{i} = T{i}(testIndex,:);
    end
    
    
    % making train and test for annotated object data
    objectsTag (objectsTag < 1) = 1; %%%% FIXXXX for zeros
    TrainObjects = cell(size(objectsTag,2),1);
    TestObjects  = cell(size(objectsTag,2),1);
    for i=1:size(objectsTag,2)
        TrainObjects{i}= objectsTag(trainIndex,i);
        TestObjects{i}= objectsTag(testIndex,i);
    end
    
    
    %%%%%%% WARNING: I removed the normalization part from previous stuffs
    %%%%%%%          to accomodate the objects stuffs
    
    
    
    %%%% Model type:
    % 0 - OBJECT->AO->Eye; AO(t-1) -> AO(t); Eye(t-1) -> Eye(t)  [Memory-dependent]
    % 0b- AO->Eye; AO(t-1) -> AO(t); Eye(t-1) -> Eye(t)  [Memory-dependent]
    %     below are [Memory-less]
    % 1 - separate OBJECT and SPATIAL
    % 2 - OBJECT -> Eye
    % 3 - OBJECT + SPATIAL -> Eye  , TODOLATER
    % 4 - object features -> AO,Eye
    % 5 - OBJECT+Feats -> AO,Eye
    % 6 - OBJ+Feats -> AO; AO->Eye
    % 7 - Feats -> AO; AO->Eye
    
    predictedP = []; predictedObj = [];
    % building classifier
    switch classifierType
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%% Control Classifiers
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        case {'Rand'} % Random
            predictedP = rand(size(TestP));
            predictedObj = rand(size(TestP,1),16);
            
        case {'MEP'} % MEP
            predictedP = repmat(mean(TrainP,1),size(TestP,1),1);
            meanAttndObj=hist(TrainObjects{11},1:16);% / length(b);
            predictedObj = repmat(meanAttndObj/(max(meanAttndObj)),size(TestP,1),1);
            
        case {'G'} % MEP
            predictedP = repmat(rGauss, [size(TestP,1) 1 ]);
            
            %%%% FIXXXX: I dont know how to do Gaussian on Attended Object
            % Use MEP here
            meanAttndObj=hist(TrainObjects{11},1:16);% / length(b);
            predictedObj = repmat(meanAttndObj/(max(meanAttndObj)),size(TestP,1),1);
        case {'BU'} % Bottom-up Saliency
            predictedP = double(T{3}(testIndex,:))./255;
        
            %%%% FIXXXX: I dont know how to do BU on Attended Object
            % Use MEP here
            meanAttndObj=hist(TrainObjects{11},1:16);% / length(b);
            predictedObj = repmat(meanAttndObj/(max(meanAttndObj)),size(TestP,1),1);
        case {'Mouse'} % Mouse
            predictedP = modelMouse(TestT{4});
            
            %%%% FIXXXX: I dont know how to do BU on Attended Object
            % Use MEP here
            meanAttndObj=hist(TrainObjects{11},1:16);% / length(b);
            predictedObj = repmat(meanAttndObj/(max(meanAttndObj)),size(TestP,1),1);
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%% Regression
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
        case{'REG0'} %
            
            %%% AO
            TrainObjPb = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            TrainObjPa = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            TestObjPb = zeros(size(TestObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)-1 %%% at time t-1
                TrainObjPb(i+1,TrainObjects{11}(i))=1; end
            for i=1:size(TestObjects{11},1)-1 %%% at time t-1
                TestObjPb(i+1,TestObjects{11}(i))=1; end
            for i=1:size(TrainObjects{11},1) %%% at time t
                TrainObjPa(i,TrainObjects{11}(i))=1; end
            
            %%% Eye
            TrainEyeb = vertcat(zeros(1,size(TrainP,2)),TrainP(1:end-1,:));
            TestEyeb  = vertcat(zeros(1,size(TestP ,2)),TestP(1:end-1,:));
            TrainEyea = TrainP;
            
            %%% Training & Testing
            predictedObj = modelRegRaw(TrainObjPb,TrainObjPa,TestObjPb);
            
            predictedP = modelRegRaw(horzcat(TrainEyeb,TrainObjPa),TrainEyea,horzcat(TestEyeb,predictedObj));
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
        case{'REG0b'} %
            
            %%% AO
            TrainObjPb = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            TrainObjPa = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            TestObjPb = zeros(size(TestObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)-1 %%% at time t-1
                TrainObjPb(i+1,TrainObjects{11}(i))=1; end
            for i=1:size(TestObjects{11},1)-1 %%% at time t-1
                TestObjPb(i+1,TestObjects{11}(i))=1; end
            for i=1:size(TrainObjects{11},1) %%% at time t
                TrainObjPa(i,TrainObjects{11}(i))=1; end
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            %%% Eye
            TrainEyeb = vertcat(zeros(1,size(TrainP,2)),TrainP(1:end-1,:));
            TestEyeb  = vertcat(zeros(1,size(TestP ,2)),TestP(1:end-1,:));
            TrainEyea = TrainP;
            
            %%% Training & Testing
            predictedObj = modelRegRaw(horzcat(TrainObj,TrainObjPb),TrainObjPa,horzcat(TestObj,TestObjPb));
            
            predictedP = modelRegRaw(horzcat(TrainEyeb,TrainObjPa),TrainEyea,horzcat(TestEyeb,predictedObj));
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
            
        case{'Regression'} % for All feature
            %%% AO
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1; end
            predictedObj = modelRegRaw(TrainObj,TrainObjP,TestObj);
            
            %%% All feature to Eye
            TrainT = horzcat(TrainT{:});
            TestT  = horzcat(TestT{:});
            predictedP = modelRegRaw(TrainT,TrainP,TestT);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
        case{'REG1b'} % for Gist only
            %%% AO
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1;
            end
            predictedObj = modelRegRaw(TrainObj,TrainObjP,TestObj);
            
            %%% Gist only to Eye
            TrainT = horzcat(TrainT{2});
            TestT  = horzcat(TestT{2});
            predictedP = modelRegRaw(TrainT,TrainP,TestT);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
        case{'REG1act'} % Action only
            %%% AO
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1;
            end
            predictedObj = modelRegRaw(TrainObj,TrainObjP,TestObj);
            
            %%% Gist only to Eye
            TrainT = horzcat(TrainT{4});
            TestT  = horzcat(TestT{4});
            predictedP = modelRegRaw(TrainT,TrainP,TestT);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
        case{'REG2'} %
            %%% AO
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1; end
            
            predictedObj = modelRegRaw(TrainObj,TrainObjP,TestObj);
            
            %%% AO to Eye
            predictedP = modelRegRaw(TrainObjP,TrainP,predictedObj);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
        case{'REG3'} %
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1; end
            
            %%% AO
            predictedObj = modelRegRaw(TrainObj,TrainObjP,TestObj);
            
            %%% Feature+AO -> Eye
            TrainT = horzcat(TrainT{:},TrainObjP);
            TestT  = horzcat(TestT{:},predictedObj);
            
            predictedP = modelRegRaw(TrainT,TrainP,TestT);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
            
        case{'REG4'} %
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1; end
            
            %%% AO
            predictedObj = modelRegRaw(TrainObj,TrainObjP,TestObj);
            
            %%% Objs -> Eye
            predictedP = modelRegRaw(TrainObj,TrainP,TestObj);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
        case{'REG5'}
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            TrainT = horzcat(TrainT{:},TrainObj);
            TestT  = horzcat(TestT{:},TestObj);
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1; end
            
            %%% AO
            predictedObj = modelRegRaw(TrainT,TrainObjP,TestT);
            
            %%% Eye
            predictedP = modelRegRaw(TrainT,TrainP,TestT);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
        case{'REG6'} %
            TrainObj = horzcat(TrainT{:},TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestT{:},TestObjects{[1:10 12]});
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1;
            end
            
            %%% AO
            predictedObj = modelRegRaw(TrainObj,TrainObjP,TestObj);
            
            %%% Eye
            predictedP = modelRegRaw(TrainObjP,TrainP,predictedObj);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
        case{'REG7'} %
            TrainObj = horzcat(TrainT{:}); TestObj  = horzcat(TestT{:});
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1; end
            
            %%% AO
            predictedObj = modelRegRaw(TrainObj,TrainObjP,TestObj);
            
            %%% Eye
            predictedP = modelRegRaw(TrainObjP,TrainP,predictedObj);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%% SVM
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
        case {'SVM0'} % "Online" AO(t-1) -> AO(t)
            %%% AO
            TrainObjPb = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            TrainObjPa = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            TestObjPa = zeros(size(TestObjects{11},1),16); %%%<<< 16 is max number of {11}
            TestObjPb = zeros(size(TestObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)-1 %%% at time t-1
                TrainObjPb(i+1,TrainObjects{11}(i))=1; end
            for i=1:size(TestObjects{11},1)-1 %%% at time t-1
                TestObjPb(i+1,TestObjects{11}(i))=1; end
            for i=1:size(TrainObjects{11},1) %%% at time t
                TrainObjPa(i,TrainObjects{11}(i))=1; end
            for i=1:size(TestObjects{11},1) %%% at time t
                TestObjPa(i,TestObjects{11}(i))=1; end
            
            %%% Eye
            TrainEyeb = vertcat(zeros(1,size(TrainP,2)),TrainP(1:end-1,:));
            TestEyeb  = vertcat(zeros(1,size(TestP ,2)),TestP(1:end-1,:));
            TrainEyea = TrainP;
            TestEyea = TestP;
            
            
            %%% Training & Test
            predictedObj = modelSVMobjOnline(TrainObjPb,TrainObjPa,TestObjPb,TestObjPa);
            
            predictedP   = modelSVM(horzcat(TrainEyeb,TrainObjPa),TrainEyea,horzcat(TestEyeb,predictedObj),TestEyea);
            
            
        case {'SVM0b'} % "Online" AO(t-1) + Objs(t) -> AO(t)
            %%% AO
            TrainObjPb = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            TrainObjPa = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            TestObjPa = zeros(size(TestObjects{11},1),16); %%%<<< 16 is max number of {11}
            TestObjPb = zeros(size(TestObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)-1 %%% at time t-1
                TrainObjPb(i+1,TrainObjects{11}(i))=1; end
            for i=1:size(TestObjects{11},1)-1 %%% at time t-1
                TestObjPb(i+1,TestObjects{11}(i))=1; end
            for i=1:size(TrainObjects{11},1) %%% at time t
                TrainObjPa(i,TrainObjects{11}(i))=1; end
            for i=1:size(TestObjects{11},1) %%% at time t
                TestObjPa(i,TestObjects{11}(i))=1; end
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            %%% Eye
            TrainEyeb = vertcat(zeros(1,size(TrainP,2)),TrainP(1:end-1,:));
            TestEyeb  = vertcat(zeros(1,size(TestP ,2)),TestP(1:end-1,:));
            TrainEyea = TrainP;
            TestEyea = TestP;
            
            
            %%% Training & Test
            predictedObj = modelSVMobjOnline(horzcat(TrainObj,TrainObjPb),TrainObjPa,horzcat(TestObj,TestObjPb),TestObjPa);
            predictedP   = modelSVM(horzcat(TrainEyeb,TrainObjPa),TrainEyea,horzcat(TestEyeb,predictedObj),TestEyea);
            
            
        case {'SVM1'} % MEP + GIST, % object-based
            predictedObj = modelSVMobj(TrainObjects,TestObjects);
            
            %%% All feature
            TrainT = horzcat(TrainT{:});
            TestT  = horzcat(TestT{:});
            predictedP = modelSVM(TrainT,TrainP,TestT,TestP);
            
        case {'SVM1act'} % Action
            predictedObj = modelSVMobj(TrainObjects,TestObjects);
            
            %%% All feature
            TrainT = horzcat(TrainT{4});
            TestT  = horzcat(TestT{4});
            predictedP = modelSVM(TrainT,TrainP,TestT,TestP);
            
        case {'SVM2'}
            predictedObj = modelSVMobj(TrainObjects,TestObjects);
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1;
            end
            
            predictedP = modelSVM(TrainObjP,TrainP,predictedObj,TestP,10);
            
        case {'SVM2Diag'} % For testing whether overfitting to train sample or not
            predictedObj = modelSVMobj(TrainObjects,TrainObjects);
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1;
            end
            
            predictedP = modelSVM(TrainObjP,TrainP,TrainObjP,TrainP,10);
            TestP = TrainP;
            TestObjects = TrainObjects;
            testIndex = trainIndex;
            
        case {'SVM3'}
            predictedObj = modelSVMobj(TrainObjects,TestObjects);
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            for i=1:size(TrainObjects{11},1)
                TrainObjP(i,TrainObjects{11}(i))=1;
            end
            TrainT = horzcat(TrainT{:},TrainObjP);
            TestT  = horzcat(TestT{:},predictedObj);
            predictedP = modelSVM(TrainT,TrainP,TestT,TestP);
            
        case {'SVM4'} %
            predictedObj = modelSVMobj(TrainObjects,TestObjects);
            
            TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            fprintf('WARNING: SVM is in linear mode')
            predictedP = modelSVMlinear(TrainObj,TrainP,TestObj,TestP);
            %predictedP = modelSVM(TrainObj,TrainP,TestObj,TestP);
            
        case {'SVM5'} %
            TrainT = horzcat(TrainT{:},TrainObjects{[1:10 12]});
            TestT  = horzcat(TestT{:},TestObjects{[1:10 12]});
            
            TrainObjP = zeros(size(TrainObjects{11},1),16); %%%<<< 16 is max number of {11}
            TestObjP = zeros(size(TestObjects{11},1),16); %%%<<< 16 is max number of {11}
            
            for i=1:size(TrainObjects{11},1) %%% at time t
                TrainObjP(i,TrainObjects{11}(i))=1; end
            for i=1:size(TestObjects{11},1) %%% at time t
                TestObjP(i,TestObjects{11}(i))=1; end
            
            predictedObj = modelSVMobjFeatures(TrainT,TrainObjP,TestT,TestObjP);
            predictedP = modelSVM(TrainT,TrainP,TestT,TestP);
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%% kNN
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            
        case {'kNN'} %
            allT = horzcat(T{:});%objectsTag(:,[1:10 12]);
            allP = P;
            %TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            TestT=horzcat(TestT{:});
            
            predictedP = modelKNN(allT,allP,TestT,gameSubjectSize,subj);
            
            %allP = objectsTag(:,11);
            
            allObjP = zeros(size(objectsTag,1),16); %%%<<< 16 is max number of {11}
            for i=1:size(objectsTag,1)
                allObjP(i,objectsTag(i,11))=1;
            end
            allObjT = objectsTag(:,[1:10 12]);
            
            predictedObj = modelKNNObj(allObjT,allObjP,TestObj,gameSubjectSize,subj);
            
        case {'kNN4'} %
            allT = objectsTag(:,[1:10 12]);
            allP = P;
            %TrainObj = horzcat(TrainObjects{[1:10 12]});
            TestObj  = horzcat(TestObjects{[1:10 12]});
            
            predictedP = modelKNN(allT,allP,TestObj,gameSubjectSize,subj);
            
            allObjP = zeros(size(objectsTag,1),16); %%%<<< 16 is max number of {11}
            for i=1:size(objectsTag,1)
                allObjP(i,objectsTag(i,11))=1;
            end
            predictedObj = modelKNNObj(allT,allObjP,TestObj,gameSubjectSize,subj);
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%% Bayesian (Static)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            
        case {'Bayes'} % Only mode - 2
            if history > 0;
                error('NOT SUPPORTED');
            end
            [predictedP predictedObj] = modelBayesAll(TrainT,TrainP,TestT,TrainObjects, TestObjects, subj);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
        case {'BayesDiag'} % For testing whether overfitting to train sample or not
            if history > 0;
                error('NOT SUPPORTED');
            end
            [predictedP predictedObj] = modelBayesAll(TrainT,TrainP,TrainT,TrainObjects, TrainObjects, subj);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            TestP = TrainP;
            TestObjects = TrainObjects;
            testIndex = trainIndex;
            
        case {'BayesV'} % Bayes Model with validation, see inside for structure
            if history > 0;
                error('NOT SUPPORTED');
            end
            objectsTag (objectsTag < 1) = 1; %%%% FIXXXX for zeros
            %%%%% To remedy overfitting <<<<---------------------------------
            Partitions = 10;
            scores = []; valIndex = cell(Partitions,1);
            for k=1:Partitions
                fprintf('--= Validation %d/%d =--\n',k,Partitions);
                rand('seed',k); tmp = randperm(length(trainIndex));
                trainValIdx = trainIndex(tmp(1:ceil(length(tmp)*.8))); %%%<<<--------- percentage
                testValIdx = setdiff(trainIndex,trainValIdx);
                valIndex{k} = tmp;
                
                TrainValP = (double(P(trainValIdx,:))); TestValP = (double(P(testValIdx,:)));
                TrainValT = cell(length(features),1);   TestValT  = cell(length(features),1);
                for i=1:length(features)
                    TrainValT{i}= T{i}(trainValIdx,:);  TestValT{i} = T{i}(testValIdx,:);
                end
                
                % making train and test for annotated object data
                TrainValObjects = cell(size(objectsTag,2),1);
                TestValObjects  = cell(size(objectsTag,2),1);
                for i=1:size(objectsTag,2)
                    TrainValObjects{i}= objectsTag(trainValIdx,i);
                    TestValObjects{i}= objectsTag(testValIdx,i);
                end
                
                [predictedP predictedObj] = modelBayesAll(TrainValT,TrainValP,TestValT,TrainValObjects, TestValObjects, subj);
                %%% FIXXX: Filling up empties with MEP
                idx=(find(max(predictedObj,[],2)==0));
                def=sum(predictedObj,1)/size(predictedObj,1);
                for i=1:length(idx); predictedObj(idx(i),:) = def; end;
                
                idx=(find(max(predictedP,[],2)==0));
                def=sum(predictedP,1)/size(predictedP,1);
                for i=1:length(idx); predictedP(idx(i),:) = def; end;
                [acc kld] = calcObjAccuracyProb(predictedObj, probAO(testValIdx,:));
                scores = [scores acc(1)];
            end
            [u v] = max(scores);
            %scores
            
            fprintf('--= Testing =--\n');
            TrainValP = (double(P(valIndex{v},:)));
            TrainValT = cell(length(features),1);
            for i=1:length(features)
                TrainValT{i}= T{i}(valIndex{v},:);
            end
            % making train and test for annotated object data
            TrainValObjects = cell(size(objectsTag,2),1);
            for i=1:size(objectsTag,2)
                TrainValObjects{i}= objectsTag(valIndex{v},i);
            end
            %%%%%%%%%%%%%---------------------------------
            
            
            % Train with the best partition again and apply it to the test
            [predictedP predictedObj] = modelBayesAll(TrainValT,TrainValP,TestT,TrainValObjects, TestObjects, subj);
            
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%% Dynamic Bayes
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            
        case {'DB'}
            [predictedP predictedObj] = modelDynBayes(TrainObjects,TestObjects,TrainP,TestP);
            % predictedObj = modelDynBayes(TrainObjects,TestObjects);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%% Online Dynamic Bayes %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        case {'oDB'} % Online version, no longer used
            error('oDB renamed to oDB0, FIX this')
            
        case {'oDB0'} % Online version
            %%% Old code, I really dont know what im doing in this one
%             [predictedP predictedObj] = modelDynBayesOnlineAOEye(TrainObjects,TestObjects,TrainP,TestP);
            %%% New code
            [predictedP predictedObj] = modelDynBayesOnlineAOEyeNew(TrainObjects,TestObjects,TrainP,TestP);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            
        case {'DBN'} % Online version
            %[predictedP predictedObj] = modelDynBayesOnline(TrainObjects,TestObjects,TrainP,TestP);
            [predictedP predictedObj] = modelDynBayesOnlineNew(TrainObjects,TestObjects,TrainP,TestP);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            
        case {'oDB0V'} % Online version
            objectsTag (objectsTag < 1) = 1; %%%% FIXXXX for zeros
            
            %%%%% To remedy overfitting <<<<---------------------------------
            Partitions = 5;
            scores = []; valIndex = cell(Partitions,1);
            for k=1:Partitions
                fprintf('--= Validation %d/%d =--\n',k,Partitions);
                rand('seed',k); tmp = randperm(length(trainIndex));
                trainValIdx = trainIndex(tmp(1:ceil(length(tmp)*.8))); %%% <<<<<---------------- percentage goes here
                testValIdx = setdiff(trainIndex,trainValIdx);
                valIndex{k} = tmp;
                
                TrainValP = (double(P(trainValIdx,:))); TestValP = (double(P(testValIdx,:)));
                TrainValT = cell(length(features),1);   TestValT  = cell(length(features),1);
                for i=1:length(features)
                    TrainValT{i}= T{i}(trainValIdx,:);  TestValT{i} = T{i}(testValIdx,:);
                end
                
                % making train and test for annotated object data
                TrainValObjects = cell(size(objectsTag,2),1);      TestValObjects  = cell(size(objectsTag,2),1);
                for i=1:size(objectsTag,2)
                    TrainValObjects{i}= objectsTag(trainValIdx,i); TestValObjects{i}= objectsTag(testValIdx,i);
                end
                
                [predictedP predictedObj] = modelDynBayesOnlineAOEye(TrainValObjects,TestValObjects,TrainValP,TestValP);
                
                %%% FIXXX: Filling up empties with MEP
                idx=(find(max(predictedObj,[],2)==0));
                def=sum(predictedObj,1)/size(predictedObj,1);
                for i=1:length(idx); predictedObj(idx(i),:) = def; end;
                
                idx=(find(max(predictedP,[],2)==0));
                def=sum(predictedP,1)/size(predictedP,1);
                for i=1:length(idx); predictedP(idx(i),:) = def; end;
                
                [acc kld] = calcObjAccuracyProb(predictedObj, probAO(testValIdx,:));
                scores = [scores acc(1)];
            end
            [u v] = max(scores); % Find highest score and use that index
            
            fprintf('--= Testing =--\n');
            TrainValP = (double(P(valIndex{v},:))); TrainValT = cell(length(features),1);
            for i=1:length(features)
                TrainValT{i}= T{i}(valIndex{v},:);
            end
            % making train and test for annotated object data
            TrainValObjects = cell(size(objectsTag,2),1);
            for i=1:size(objectsTag,2)
                TrainValObjects{i}= objectsTag(valIndex{v},i);
            end
            %%%%%%%%%%%%%---------------------------------
            
            [predictedP predictedObj] = modelDynBayesOnlineAOEye(TrainValObjects,TestObjects,TrainValP,TestP);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            
        case {'oDB0bV'} % Online version
            objectsTag (objectsTag < 1) = 1; %%%% FIXXXX for zeros
            
            %%%%% To remedy overfitting <<<<---------------------------------
            Partitions = 5;
            scores = []; valIndex = cell(Partitions,1);
            for k=1:Partitions
                fprintf('--= Validation %d/%d =--\n',k,Partitions);
                rand('seed',k); tmp = randperm(length(trainIndex));
                trainValIdx = trainIndex(tmp(1:ceil(length(tmp)*.8))); %%% <<<<<---------------- percentage goes here
                testValIdx = setdiff(trainIndex,trainValIdx);
                valIndex{k} = tmp;
                
                TrainValP = (double(P(trainValIdx,:))); TestValP = (double(P(testValIdx,:)));
                TrainValT = cell(length(features),1);   TestValT  = cell(length(features),1);
                for i=1:length(features)
                    TrainValT{i}= T{i}(trainValIdx,:);  TestValT{i} = T{i}(testValIdx,:);
                end
                
                % making train and test for annotated object data
                TrainValObjects = cell(size(objectsTag,2),1);      TestValObjects  = cell(size(objectsTag,2),1);
                for i=1:size(objectsTag,2)
                    TrainValObjects{i}= objectsTag(trainValIdx,i); TestValObjects{i}= objectsTag(testValIdx,i);
                end
                
                [predictedP predictedObj] = modelDynBayesOnline(TrainValObjects,TestValObjects,TrainValP,TestValP);
                
                %%% FIXXX: Filling up empties with MEP
                idx=(find(max(predictedObj,[],2)==0));
                def=sum(predictedObj,1)/size(predictedObj,1);
                for i=1:length(idx); predictedObj(idx(i),:) = def; end;
                
                idx=(find(max(predictedP,[],2)==0));
                def=sum(predictedP,1)/size(predictedP,1);
                for i=1:length(idx); predictedP(idx(i),:) = def; end;
                
                [acc kld] = calcObjAccuracyProb(predictedObj, probAO(testValIdx,:));
                scores = [scores acc(1)];
            end
            [u v] = max(scores); % Find highest score and use that index
            
            fprintf('--= Testing =--\n');
            TrainValP = (double(P(valIndex{v},:))); TrainValT = cell(length(features),1);
            for i=1:length(features)
                TrainValT{i}= T{i}(valIndex{v},:);
            end
            % making train and test for annotated object data
            TrainValObjects = cell(size(objectsTag,2),1);
            for i=1:size(objectsTag,2)
                TrainValObjects{i}= objectsTag(valIndex{v},i);
            end
            %%%%%%%%%%%%%---------------------------------
            
            [predictedP predictedObj] = modelDynBayesOnline(TrainValObjects,TestObjects,TrainValP,TestP);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%% Online Dynamic Bayes with Soft Evidence%%%%%%%%%%%%%%%%%%%
            
        case {'oDBa'} % Online version using soft-evidence
            error('oDBa renamed to oDB0s, FIX this')
            
        case {'oDB0s'} % Online version using soft-evidence
            TestAO = probAO(testIndex,:);
            TrainAO = probAO(trainIndex,:);
            
            [predictedP predictedObj] = modelDynBayesOnlineSoftAOEye(TrainObjects,TestObjects,TrainP,TestP,TrainAO,TestAO);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            
        case {'oDB0bs'} % Online version using soft-evidence
            TestAO = probAO(testIndex,:);
            TrainAO = probAO(trainIndex,:);
            
            [predictedP predictedObj] = modelDynBayesOnlineSoft(TrainObjects,TestObjects,TrainP,TestP,TrainAO,TestAO);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            
        case {'oDB0sV'} % Online version using soft-evidence & Validation
            objectsTag (objectsTag < 1) = 1; %%%% FIXXXX for zeros
            %%%%% To remedy overfitting <<<<---------------------------------
            Partitions = 5;
            scores = []; valIndex = cell(Partitions,1);
            for k=1:Partitions
                fprintf('--= Validation %d/%d =--\n',k,Partitions);
                rand('seed',k); tmp = randperm(length(trainIndex));
                trainValIdx = trainIndex(tmp(1:ceil(length(tmp)*.8))); %%% <<<<<---------------- percentage goes here
                testValIdx = setdiff(trainIndex,trainValIdx);
                valIndex{k} = tmp;
                
                %%% Datas
                TestValAO = probAO(testValIdx,:);      TrainValAO = probAO(trainValIdx,:);
                TrainValP = (double(P(trainValIdx,:)));TestValP = (double(P(testValIdx,:)));
                TrainValT = cell(length(features),1);  TestValT  = cell(length(features),1);
                for i=1:length(features)
                    TrainValT{i}= T{i}(trainValIdx,:); TestValT{i} = T{i}(testValIdx,:);
                end
                
                % making train and test for annotated object data
                TrainValObjects = cell(size(objectsTag,2),1); TestValObjects  = cell(size(objectsTag,2),1);
                for i=1:size(objectsTag,2)
                    TrainValObjects{i}= objectsTag(trainValIdx,i); TestValObjects{i}= objectsTag(testValIdx,i);
                end
                
                [predictedP predictedObj] = modelDynBayesOnlineSoftAOEye(TrainValObjects,TestValObjects,TrainValP,TestValP,TrainValAO,TestValAO);
                %%% FIXXX: Filling up empties with MEP
                idx=(find(max(predictedObj,[],2)==0));
                def=sum(predictedObj,1)/size(predictedObj,1);
                for i=1:length(idx); predictedObj(idx(i),:) = def; end;
                idx=(find(max(predictedP,[],2)==0));
                def=sum(predictedP,1)/size(predictedP,1);
                for i=1:length(idx); predictedP(idx(i),:) = def; end;
                
                [acc kld] = calcObjAccuracyProb(predictedObj, probAO(testValIdx,:));
                scores = [scores acc(1)];
            end
            [u v] = max(scores); % Find highest score and use that index
            
            fprintf('--= Testing =--\n');
            TrainValP = (double(P(valIndex{v},:))); TrainValT = cell(length(features),1);
            for i=1:length(features)
                TrainValT{i}= T{i}(valIndex{v},:);
            end
            % making train and test for annotated object data
            objectsTag (objectsTag < 1) = 1; %%%% FIXXXX for zeros
            TrainValObjects = cell(size(objectsTag,2),1);
            for i=1:size(objectsTag,2)
                TrainValObjects{i}= objectsTag(valIndex{v},i);
            end
            %%%%%%%%%%%%%---------------------------------
            TestAO = probAO(testIndex,:);
            TrainAO = probAO(valIndex{v},:);
            
            [predictedP predictedObj] = modelDynBayesOnlineSoftAOEye(TrainObjects,TestObjects,TrainP,TestP,TrainAO,TestAO);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            
        case {'oDB0bsV'} % Online version using soft-evidence & Validation
            objectsTag (objectsTag < 1) = 1; %%%% FIXXXX for zeros
            %%%%% To remedy overfitting <<<<---------------------------------
            Partitions = 5;
            scores = []; valIndex = cell(Partitions,1);
            for k=1:Partitions
                fprintf('--= Validation %d/%d =--\n',k,Partitions);
                rand('seed',k); tmp = randperm(length(trainIndex));
                trainValIdx = trainIndex(tmp(1:ceil(length(tmp)*.8))); %%% <<<<<---------------- percentage goes here
                testValIdx = setdiff(trainIndex,trainValIdx);
                valIndex{k} = tmp;
                
                %%% Datas
                TestValAO = probAO(testValIdx,:);      TrainValAO = probAO(trainValIdx,:);
                TrainValP = (double(P(trainValIdx,:)));TestValP = (double(P(testValIdx,:)));
                TrainValT = cell(length(features),1);  TestValT  = cell(length(features),1);
                for i=1:length(features)
                    TrainValT{i}= T{i}(trainValIdx,:); TestValT{i} = T{i}(testValIdx,:);
                end
                
                % making train and test for annotated object data
                TrainValObjects = cell(size(objectsTag,2),1); TestValObjects  = cell(size(objectsTag,2),1);
                for i=1:size(objectsTag,2)
                    TrainValObjects{i}= objectsTag(trainValIdx,i); TestValObjects{i}= objectsTag(testValIdx,i);
                end
                
                [predictedP predictedObj] = modelDynBayesOnlineSoft(TrainValObjects,TestValObjects,TrainValP,TestValP,TrainValAO,TestValAO);
                %%% FIXXX: Filling up empties with MEP
                idx=(find(max(predictedObj,[],2)==0));
                def=sum(predictedObj,1)/size(predictedObj,1);
                for i=1:length(idx); predictedObj(idx(i),:) = def; end;
                idx=(find(max(predictedP,[],2)==0));
                def=sum(predictedP,1)/size(predictedP,1);
                for i=1:length(idx); predictedP(idx(i),:) = def; end;
                
                [acc kld] = calcObjAccuracyProb(predictedObj, probAO(testValIdx,:));
                scores = [scores acc(1)];
            end
            [u v] = max(scores); % Find highest score and use that index
            
            fprintf('--= Testing =--\n');
            TrainValP = (double(P(valIndex{v},:))); TrainValT = cell(length(features),1);
            for i=1:length(features)
                TrainValT{i}= T{i}(valIndex{v},:);
            end
            % making train and test for annotated object data
            objectsTag (objectsTag < 1) = 1; %%%% FIXXXX for zeros
            TrainValObjects = cell(size(objectsTag,2),1);
            for i=1:size(objectsTag,2)
                TrainValObjects{i}= objectsTag(valIndex{v},i);
            end
            %%%%%%%%%%%%%---------------------------------
            TestAO = probAO(testIndex,:);
            TrainAO = probAO(valIndex{v},:);
            
            [predictedP predictedObj] = modelDynBayesOnlineSoft(TrainObjects,TestObjects,TrainP,TestP,TrainAO,TestAO);
            
            %%% FIXXX: Filling up empties with MEP
            idx=(find(max(predictedObj,[],2)==0));
            def=sum(predictedObj,1)/size(predictedObj,1);
            for i=1:length(idx); predictedObj(idx(i),:) = def; end;
            
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%% HMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
        case {'HMM'}
            %predictedObj = modelHMM(TrainObjects,TestObjects);
            [predictedP predictedObj] = modelHMMwEye(TrainObjects,TestObjects,TrainP,TestP);
            
    end  % classifierType
    

    %%% Global Fix: Filling up empties with MEP
    idx=(find(max(predictedObj,[],2)==0));
    def=sum(predictedObj,1)/size(predictedObj,1);
    for i=1:length(idx); predictedObj(idx(i),:) = def; end;
    
    idx=(find(max(predictedP,[],2)==0));
    def=sum(predictedP,1)/size(predictedP,1);
    for i=1:length(idx); predictedP(idx(i),:) = def; end;

    
    
    
    
    
    % ------------------------------------------------------------
    %     se1 = strel('square',15);
    %     % save some maps for later checking
    %     for j=1:50:size(predictedP,1)
    %         img = reshape(predictedP(j,:)./max(max(predictedP(j,:))),[15 20]);
    %         img = imresize(img, [150 200], 'nearest');
    %         img(isnan(img)==0);
    %         %             img = imdilate(img, se1);
    %         imwrite(img, [salMapPath int2str(gameNo) '-' int2str(subj) '-' int2str(j) '.jpg']);
    %     end
    
    %%% For calcNSS
    %addpath('/lab/tmpir/u/dicky/data/Parsed/mapCombi');
    
    %%%% doing some percentage calculation here
    %     numPercentageCut = 10;
    %     predictedP = predictedP - min(min(predictedP));
    %     leScore = cell(numPercentageCut,1);
    %     leScoreSEM=cell(numPercentageCut,1);
    %     for cutOff=0:numPercentageCut-1
    %         maxPred = max(max(predictedP));
    %         maxCut  = ((numPercentageCut - cutOff)/numPercentageCut) * maxPred;
    %         index   = (predictedP > maxCut);
    %         % What we want to do with the index?
    %         tmpPred = predictedP;
    %         tmpTest = TestP;
    %         % 1. Make everything in index zero with the eyepos zero
    %         tmpPred(index) = 0;
    %         tmpTest(index) = 0;
    %         % 2. Put limit to them
    %
    %         % do the calcNSS
    %         [leScore{cutOff+1} leScoreSEM{cutOff+1}] = calcNSS(tmpPred, tmpTest);
    %     end
    %     scores = vertcat(leScore{:});
    %     scoresSEM= vertcat(leScoreSEM{:});
    %
    
    % Calculating AUC before cutting stuff - Ali
    
    if ~isempty(predictedP)
        
        [scoresMeanAUC scoresStdAUC xx]= calcMyAUC(predictedP,TestP);
        gameAUCScores = [gameAUCScores scoresMeanAUC];
        RRR{subj} = xx;
        
        %%%% doing some percentage calculation here
        numPercentageCut = 10;
        %predictedP = predictedP - min(min(predictedP));
        myMEP = sum(TrainP,1);
        
        if strcmp(classifierType, 'G') == 1
            myMEP = rGauss;
        end
        
        %     myMEP = sum(predictedPT,1);
        
        tmpScores = []; otherScores = [];
        invalidIdxmatrix = [];
        %figure
        for cutOff=0:numPercentageCut-1
            maxPred = max(max(myMEP));
            minPred = min(min(myMEP));
            maxCut  = (((numPercentageCut - cutOff)/numPercentageCut) * (maxPred-minPred))+minPred;
            index   = (myMEP > maxCut);
            invalidIndices = index;
            invalidIdxmatrix = [invalidIdxmatrix ; invalidIndices];
            
            %subplot(gameSubjectSize(gameNo),10,(subj-1)*10+cutOff+1);
            tmpMEP = myMEP;
            tmpMEP(index) = 0;
            %imshow(reshape(tmpMEP,[15 20]));
            if iscell(TestT)
                ppp = repmat(myMEP, [size(TestT{1},1) 1 ]);
            else
                ppp = repmat(myMEP, [size(TestT,1) 1 ]);
            end
            [leScore leScoreSEM] = calcNSSInvalid(ppp, TestP, invalidIndices);
            tmpScores = [tmpScores leScore];
            [leScore scoresSEM] = calcNSSInvalid(predictedP, TestP, invalidIndices);
            otherScores = [otherScores leScore];
            
        end
        %     figure; plot(tmpScores,'b')
        %     hold on; plot(otherScores,'r')
        [u v] = min(tmpScores);
        invalidIndices = invalidIdxmatrix(v,:);
        
        
        %[scores scoresSEM] = calcNSS(predictedP,TestP);
        %gameScores = [gameScores scores ];
        gameScores = [gameScores otherScores' ];
        %gameScoresSEM = [gameScoresSEM scoresSEM ];
    end
    
    
    
    %%%% Object-based scoring
    if ~isempty(predictedObj)
        [a b] = max(predictedObj,[],2);
        numRight = sum(b==TestObjects{11}); % attended obj
        accuracyBAY = numRight / length(b);
        
        meanAttndObj=hist(TrainObjects{11},1:16);% / length(b);
        [u v] = max(meanAttndObj);
        numRight = sum(TestObjects{11}==v); % attended obj
        accuracyMAO= numRight / length(b);
        
        accuracyRAND = zeros(length(b),1);
        for i=1:length(b);
            %tmp = find(TestObjects{11}(i)>1);
            tmp = find(objectsTag(testIndex(i),1:10) > 1);
            %if ~isempty(tmp)
            accuracyRAND(i) = 1/(length(tmp)+5); %% 4 comes from pools & trash
            %end
        end
        %     accuracyBAY
        %     accuracyMAO
        %     accuracyRAND
        accuracyRANDz = mean(accuracyRAND);
        %randomObj = randi(16,[length(b) 1]);
        %numRight = sum(randomObj==v); % attended obj
        %accuracyRAND= numRight / length(b);
        
        gameScoresSEM = [gameScoresSEM; accuracyBAY accuracyMAO accuracyRANDz];
    end
    
    predictedPAll = [predictedPAll; predictedP];
    predictedObjAll = [predictedObjAll;predictedObj];
    eyePositions = [eyePositions; TestP];
    toc
end

end % function
