function [ gameScores predictedP eyePositions gameAUCScores RRR ] = modelClassifier3DDS( features, positions, classifierType)
%Model building for 3DDS
global gameSubjectSize;
global Res;
global patches;

gameScores = [];
gameScoresSEM = [];
predictedP = [];
eyePositions = [];
gameAUCScores = [];

RRR = cell(1,length(gameSubjectSize));

allIndex = cell(length(gameSubjectSize),1);
for i=1:length(gameSubjectSize)
    startNo=sum(gameSubjectSize(1:i-1));
    allIndex{i} = startNo+1 : startNo+gameSubjectSize(i);
end

P = positions;
T = cell(length(features),1);
for i=1:length(features)
    IDX=features{i};
    T{i} = IDX;
end
for subj=1:1%length(gameSubjectSize)
    fprintf('%d%s%d ', 2, '-', subj); tic;
    
    
    allsubj = 1:length(gameSubjectSize);
    testIndex = allIndex{subj};
    trainIndex = horzcat(allIndex{allsubj~=subj});
    %%% Done Index making
    TrainP = (double(P(trainIndex,:)));
    TestP = (double(P(testIndex,:)));
    
    
    
    switch classifierType
        case {'kNN'}
            TestT  = cell(3,1);
            for i=1:3
                TestT{i} = T{i}(testIndex,:);
            end
            allT = horzcat(T{:});%objectsTag(:,[1:10 12]);
            allP = P;
            TestT=horzcat(TestT{:});
            
            predictedP = modelKNN(allT,allP,TestT,gameSubjectSize,subj);
            
        case {'MEP'}
            predictedP = repmat(mean(TrainP,1),size(TestP,1),1);
            
        case {'Rand'}
            predictedP = rand(size(TestP));
            
        case {'Regression'}
            TrainT = cell(3,1);
            TestT  = cell(3,1);
            for i=1:3
                TrainT{i}= T{i}(trainIndex,:);
                TestT{i} = T{i}(testIndex,:);
            end
            TrainT = horzcat(TrainT{:});
            TestT  = horzcat(TestT{:});
            predictedP = modelRegRaw(TrainT,TrainP,TestT);
            predictedP(predictedP<0) = 0; %%% Throw away all minuses
            
        case {'DBN'} 
            TrainT = cell(2,1);
            TestT  = cell(2,1);
            for i=1:2
                TrainT{i}= T{i}(trainIndex,:);
                TestT{i} = T{i}(testIndex,:);
            end
            predictedP = modelDynBayes3DDS(TrainT,TestT,TrainP,TestP);
            idx=(find(max(predictedP,[],2)==0));
            def=sum(predictedP,1)/size(predictedP,1);
            for i=1:length(idx); predictedP(idx(i),:) = def; end;
    end
    
    if ~isempty(predictedP)
        
        [scoresMeanAUC scoresStdAUC xx]= calcMyAUC(predictedP,TestP);
        gameAUCScores = [gameAUCScores scoresMeanAUC];
        RRR{subj} = xx;
        numPercentageCut = 10;
        myMEP = sum(TrainP,1);
        
        tmpScores = []; otherScores = [];
        invalidIdxmatrix = [];
        %figure
        for cutOff=0:numPercentageCut-1
            maxPred = max(max(myMEP));
            minPred = min(min(myMEP));
            maxCut  = (((numPercentageCut - cutOff)/numPercentageCut) * (maxPred-minPred))+minPred;
            index   = (myMEP > maxCut);
            invalidIndices = index;
            invalidIdxmatrix = [invalidIdxmatrix ; invalidIndices];
            
            %subplot(gameSubjectSize(gameNo),10,(subj-1)*10+cutOff+1);
            %tmpMEP = myMEP;
            %tmpMEP(index) = 0;
            %if iscell(TestT)
            %    ppp = repmat(myMEP, [size(TestT{1},1) 1 ]);
            %else
            %    ppp = repmat(myMEP, [size(TestT,1) 1 ]);
            %end
            %[leScore leScoreSEM] = calcNSSInvalid(ppp, TestP, invalidIndices);
            %tmpScores = [tmpScores leScore];
            [leScore scoresSEM] = calcNSSInvalid(predictedP, TestP, invalidIndices);
            otherScores = [otherScores leScore];
            
        end
        %     figure; plot(tmpScores,'b')
        %     hold on; plot(otherScores,'r')
        [u v] = min(tmpScores);
        invalidIndices = invalidIdxmatrix(v,:);
        gameScores = [gameScores otherScores' ];
    end
end
end

