% here we are going to make a temporal bayes net (dbn) for the driving
% experiment

function [predictedP] = modelDynBayes3DDS(myTrainT,myTestT,myTrainP, myTestP)
global Res;

addbnt;
hidden_ns = 3;
max_iter=1;
T = 2;

myMapTotal= Res(1)*Res(2);
[c TrainP] = max(myTrainP,[],2);
[c TestP] = max(myTestP,[],2);

% MAKING NETWORK ---------------------------------
fprintf('Making DB network..\n');
[bnet nodes] = mk_our_bnet_3DDS(myMapTotal,hidden_ns);
fieldNames = { ...
     'LS';
     'RS';
     'M';
     'LV';
     'RV';
     'GC';
     'E';
     'Eye'; 
    };
for i=1:length(fieldNames)
    eval([fieldNames{i} '= 0;']);
    eval(['if isfield(nodes,''' fieldNames{i} '''); ' fieldNames{i} ' = nodes.' fieldNames{i} '; end;'])
end
N = length(struct2cell(nodes)); % num variables

% TRAINING ---------------------------------
%fprintf('Building up sample..\n');
% Train & Test data
myTrain = cell(N,1);
myTest = cell(N,1);
for i=1:length(fieldNames)
    if strcmp(fieldNames{i},'Eye')
        eval(['if(' fieldNames{i} '); myTrain{' fieldNames{i} '} = TrainP; myTrain{' fieldNames{i} '}(myTrain{' fieldNames{i} '} < 1) = 1; end;'])
        eval(['if(' fieldNames{i} '); myTest{'  fieldNames{i} '} = TestP; myTest{'  fieldNames{i} '}(myTest{'  fieldNames{i} '} < 1) = 1; end;'])
    elseif strcmp(fieldNames{i},'E')
        eval(['if(' fieldNames{i} '); myTrain{' fieldNames{i} '} = myTrainT{2}; myTrain{' fieldNames{i} '}(myTrain{' fieldNames{i} '} < 1) = 1; end;'])
        eval(['if(' fieldNames{i} '); myTest{'  fieldNames{i} '} = myTestT{2} ; myTest{'  fieldNames{i} '}(myTest{'  fieldNames{i} '} < 1) = 1; end;'])
    elseif strcmp(fieldNames{i},'LS')
        eval(['if(' fieldNames{i} '); myTrain{' fieldNames{i} '} = myTrainT{1}(:,5); myTrain{' fieldNames{i} '}(myTrain{' fieldNames{i} '} < 1) = 1; end;'])
        eval(['if(' fieldNames{i} '); myTest{'  fieldNames{i} '} = myTestT{1}(:,5); myTest{'  fieldNames{i} '}(myTest{'  fieldNames{i} '} < 1) = 1; end;'])
    elseif strcmp(fieldNames{i},'RS')
        eval(['if(' fieldNames{i} '); myTrain{' fieldNames{i} '} = myTrainT{1}(:,6); myTrain{' fieldNames{i} '}(myTrain{' fieldNames{i} '} < 1) = 1; end;'])
        eval(['if(' fieldNames{i} '); myTest{'  fieldNames{i} '} = myTestT{1}(:,6); myTest{'  fieldNames{i} '}(myTest{'  fieldNames{i} '} < 1) = 1; end;'])
    elseif strcmp(fieldNames{i},'M')
        eval(['if(' fieldNames{i} '); myTrain{' fieldNames{i} '} = myTrainT{1}(:,7); myTrain{' fieldNames{i} '}(myTrain{' fieldNames{i} '} < 1) = 1; end;'])
        eval(['if(' fieldNames{i} '); myTest{'  fieldNames{i} '} = myTestT{1}(:,7); myTest{'  fieldNames{i} '}(myTest{'  fieldNames{i} '} < 1) = 1; end;'])
    elseif strcmp(fieldNames{i},'LV')
        eval(['if(' fieldNames{i} '); myTrain{' fieldNames{i} '} = myTrainT{1}(:,8); myTrain{' fieldNames{i} '}(myTrain{' fieldNames{i} '} < 1) = 1; end;'])
        eval(['if(' fieldNames{i} '); myTest{'  fieldNames{i} '} = myTestT{1}(:,8); myTest{'  fieldNames{i} '}(myTest{'  fieldNames{i} '} < 1) = 1; end;'])
    elseif strcmp(fieldNames{i},'RV')
        eval(['if(' fieldNames{i} '); myTrain{' fieldNames{i} '} = myTrainT{1}(:,9); myTrain{' fieldNames{i} '}(myTrain{' fieldNames{i} '} < 1) = 1; end;'])
        eval(['if(' fieldNames{i} '); myTest{'  fieldNames{i} '} = myTestT{1}(:,9); myTest{'  fieldNames{i} '}(myTest{'  fieldNames{i} '} < 1) = 1; end;'])
     elseif strcmp(fieldNames{i},'GC')
        eval(['if(' fieldNames{i} '); myTrain{' fieldNames{i} '} = myTrainT{1}(:,10); myTrain{' fieldNames{i} '}(myTrain{' fieldNames{i} '} < 1) = 1; end;'])
        eval(['if(' fieldNames{i} '); myTest{'  fieldNames{i} '} = myTestT{1}(:,10); myTest{'  fieldNames{i} '}(myTest{'  fieldNames{i} '} < 1) = 1; end;'])
    end
end
nsample = length(myTrainT{1});
sample = cell(N,nsample);
for l=1:nsample
    for i=1:length(fieldNames)
        eval(['if(' fieldNames{i} '); sample{' fieldNames{i} ',l}  = myTrain{' fieldNames{i} '}(l,:); end;'])
    end
end

%engine = jtree_dbn_inf_engine(bnet);
%%% Learning the network
fprintf('Learning (Full observed)..\n');
bnet2 = learn_params_dbn(bnet,sample);

engine = jtree_inf_engine(bnet2);
%engine = jtree_dbn_inf_engine(bnet);


%%% Testing the accuracy and get maps
mapEyeCell = cell(size(myTestT{1},1),1);
% Frame by frame data input
Tz = T;
prevEye = cell(Tz-1,1);
for frameNo=1:size(myTestT{1},1)
    evidence = cell(N,T);
    for ab=1:Tz-1
        if (frameNo-ab < 1); continue; end
        evidence{Eye,T-ab} = myTest{Eye}(frameNo-ab);
    end
    for ab=0:T-1
        if (frameNo-ab < 1); continue; end
        for i=1:length(fieldNames)
            if strcmp(fieldNames{i},'Eye')
                continue
            end
            eval(['if(' fieldNames{i} '); evidence{' fieldNames{i} ', T-ab} = myTest{' fieldNames{i} '}(frameNo-ab); end;'])
        end
%         evidence{Feat, ab+1} = myTest{Feat}(frameNo-ab);
    end
    [engine, loglik] = enter_evidence(engine, evidence);
    
    for ab=2:Tz
    prevEye{ab} = prevEye{ab-1};
    end
    
    marg = marginal_nodes(engine, Eye, T);
    mapEyeCell{frameNo} = marg.T';
    prevEye{1} = marg.T;
    
end % testing
predictedP = vertcat(mapEyeCell{:});

end

