clc
clear all
warning off all %%% Shut up matlab! I only need error, not warning
global Res;
global theGistCluster;
% --------------------------------------------
% Parameters

Res = [15 20]; % map size, must be 4:3 ratio.
numSubj = 5; % number of subject teste
frameSkip = 1; % frame skip, since each frame theres not much differences
theGistCluster = 20; % we tried clustering gist as input to bayes but it didnt work

isJumpSaccade = false; % TODO
isOldJump = true; % TODO
isOnline = true; % true for memory-dependent, false for memory-less
samplingProb = 5;

% --------------------------------------------
% Making Gauss, TODO: replace with fspecial
%global rGauss;
%dims = [34 34]; sigma = 3; % gaussian standard deviation in pixels
%P = [round(dims(1)/2) round(dims(2)/2)];
%[Xm Ym] = meshgrid(-P(2):P(2), -P(1):P(1)); s = sigma ;
%gauss = exp(-((( Xm.^2)+( Ym.^2)) ./ (2* s^2)));
%gauss = imresize(gauss, [20 15]);
%rGauss = reshape(gauss', [1 300]);
% ----
global featurePath;
global savePath;
global gameSubjectSize;

global objects;
global patches;
global probAO;
%%%%%%%%%%init;

fprintf('Vgames3\n');
featurePath = './data/';
gameNo = 1;

fprintf('Running game %d\n',gameNo);

% Load single subject data
fprintf('Loading data '); tic;
%load([featurePath 'vg3_HDB_fix.mat']);
load([featurePath 'vg3_HDB_sacc.mat']);
if ~isJumpSaccade || isOldJump
    objTag=cell(5,1);
    for i=1:5
        load(['./taggedData/objectsTag_true_HD' num2str(i) '.mat'])
        %objTag{i} = objectsTag(3000:6000);                             %the middle video
		temp=[];
		j=1;
		%while(j<=size(bumap{i},1))				%the number of frames that we have,take only two frames per second
		%	temp=[temp;objectsTag(frame{i}(j,1),:)];
	%		j=j+frameSkip;
	%	end
		objTag{i}=objectsTag(frame{i}(:,1),:);
    end
else
    objTag=cell(5,1); frameTag=cell(5,1);
    for i=1:5
        load(['./taggedData/objectsTag_truefix_HD' num2str(i) '.mat'])
        objTag{i} = fixedTag;
        %frameTag{i} = frame;
    end
end

%%% Prob Object AO
objAO=cell(5,1);
for i=1:5
    load(['./taggedData/objectsTag_true_probAO_HD' num2str(i) '.mat'])
    %objAO{i} = probAO(3000:6000);
	temp=[];
	j=1;
	%while(j<=size(bumap{i},1))				%the number of frames that we have,take only two frames per second
%		temp=[temp;probAO(frame{i}(j,1),:)];
%		j=j+frameSkip;
%	end
	objAO{i}=probAO(frame{i}(:,1),:);
end
toc

% Group all into one giant map
fprintf('Grouping to cells '); tic;
gameSubjectSize=zeros(1,numSubj);
theMap = cell(4,1); eyePos = []; allhand = []; objTagData=[]; probAO=[];
for i=1:numSubj
    if ~isJumpSaccade
        tmp = find(objTag{i}(:,11) ~= 16 & objTag{i}(:,11) ~= 0 & sum(objTag{i}(:,1:10),2)>10);     %based on the number of objects in the scene
    else
        if ~isOldJump
            %%%% New one
            tmp = frameTag{i};
        else
            %%%% Old Jump Saccade
            tmp = []; oldOne = 16; %%% These are for removing stuffs
            for j=1:size(objTag{i},1)
                if objTag{i}(j,11) == 0 || objTag{i}(j,11) == 16; continue;end
                if objTag{i}(j,11) ~= oldOne
                    tmp = [tmp j];
                    oldOne = objTag{i}(j,11);
                end
            end
        end
    end
    
    % note: tmp is the index. since we either want or dont want to deal
    % with the non-attended object
    
    gameSubjectSize(i)=length(tmp);
    theMap{1} = vertcat(theMap{1},double(ones(length(tmp),1))); % MEP
    theMap{2} = vertcat(theMap{2},gist{i}(tmp,:)); % gist
    theMap{3} = vertcat(theMap{3},downscaleMap(bumap{i}(tmp,:),Res)); % BU map
    %theMap{4} = vertcat(theMap{4},round(hand{i}(tmp,1)./32)); % X
    %theMap{5} = vertcat(theMap{5},round(hand{i}(tmp,2)./32)); % Y
    eyePos = vertcat(eyePos,downscaleMap(eyemap{i}(tmp,:),Res)); % eye
    %allhand = vertcat(allhand,round(hand{i}(tmp,:))); % X + Y + buttons
    %theMap{4} = vertcat(allhand,round(hand{i}(tmp,:))); % X + Y + buttons
    theMap{4} = vertcat(theMap{4},round(hand{i}(tmp,:))); % X
    if length(tmp) == size(objTag{i},1)
        objTagData = vertcat(objTagData, objTag{i});
    else
        objTagData = vertcat(objTagData, objTag{i}(tmp,:));
    end
    probAO = vertcat(probAO, objAO{i}(tmp,:));
end
theLabels={'MEP', 'Gist', 'BUmap', 'Mouse'};
toc


%%% Ali's concept to make objects binary
for i=1:size(objTagData,1)
    for j=1:10
        objTagData(i,j) = (objTagData(i,j) > 1) + 1;
    end
end


% ---------------------------------------- pdf over attended object
fprintf('Building pdf');tic;
if isOnline
    % generating data for dynamic classifiers
    
    %attendedO, pdf over attended object
    newFeature = cell(4,1);
    newFeature{1} = zeros(size(probAO,1)*samplingProb,size(theMap{1},2));
    newFeature{2} = zeros(size(probAO,1)*samplingProb,size(theMap{2},2));
    newFeature{3} = zeros(size(probAO,1)*samplingProb,size(theMap{3},2));
    newFeature{4} = zeros(size(probAO,1)*samplingProb,size(theMap{4},2));
    newPositions = zeros(size(probAO,1)*samplingProb,size(eyePos,2));
    newObjectTag = zeros(size(probAO,1)*samplingProb,size(objTagData,2));
    newProbAO    = zeros(size(probAO,1)*samplingProb,size(probAO,2));
    
    for j=1:samplingProb                                                    %my modifications in the pdf
        for i=1:size(probAO,1)
            %a = cumsum(probAO(i,:));
            a=probAO(i,:);
            mn=mean(probAO(i,:));
            sd=std(probAO(i,:));
            %r = rand(1);
            %u  = find(a >= r);
            u=find(a>=mn+0.5*sd);
            [hi,p]=size(u);
            ind=randi(hi,1);
            for k=1:4
                newFeature{k}(((j-1)*size(probAO,1))+i,:) = theMap{k}(i,:);
            end
            newPositions(((j-1)*size(probAO,1))+i,:) = eyePos(i,:);
            %newObjectTag(((j-1)*size(probAO,1))+i,:) = [objTagData(i,1:10) u(1) objTagData(i,12)];
            newObjectTag(((j-1)*size(probAO,1))+i,:) = [objTagData(i,1:10) u(ind) objTagData(i,12)];
            newProbAO(((j-1)*size(probAO,1))+i,:)    = probAO(i,:);
        end                                                                 %ending my modifications
        
    end
    
    % replacement
    theMap = newFeature;
    eyePos = newPositions;
    objTagData = newObjectTag;
    gameSubjectSize = gameSubjectSize * samplingProb;
    probAO = newProbAO;
end
toc
% ------------------------------------------------------


if ~isOnline %%% Offline Case
    labelName = { ...
        %'MEP'  % Mean Eye Position
        %'Rand' % Pseudo-Random
        %'G'    % Gaussian
        %'BU'   % Bottom-up Saliency
        %'Mouse'
        %             'REG1a'% Offline REG: Objs->AO; Feat(all)->Eye
       % 'REG1b'% Offline REG: Objs->AO; Feat(gist)->Eye
        %'REG1act'
        %             'REG2'
        %             'REG3'
        %             'REG4'
        %             'REG5'
        %             'REG6'
        %             'REG7'
        %             'SVM1'
        %'SVM1act'
        %             'SVM2'
        %             'SVM3'
        %'SVM4'
        %             'SVM5'
       % 'kNN1'
        %             'kNN4'
        'Bayes'  %%% Without Validation
        %             'BayesV' %%% With validation
        'DB'
        };
else %%% Online Case
    labelName = { ...
        'MEP'  % Mean Eye Position
        'Rand' % Pseudo-Random
        'kNN'
        'Regression'
        %'G'    % Gaussian
        %'BU'   % Bottom-up Saliency
        %'Mouse' % Mouse
        %             'REG0' % Online REG: AO & Eye
        %             'REG0b'% Online REG: Objs, AO, & Eye
        %             'SVM0' % Online SVM: AO & Eye
        %             'SVM0b'% Online SVM: Objs, AO, & Eye
        'DBN'   % Online DBN: AO -> Eye
        %'oDB0V'  % Online DBN: AO -> Eye, with Validation
        %'DBN'  % Online DBN: see dyn bayes net
        %'oDB0bV' % Online DBN: see dyn bayes net, with Validation
        %'oDB0s'  % Online DBN: AO -> Eye, using soft evidence
        %             'oDB0sV' % Online DBN: AO -> Eye, using soft evidence, with Validation
        %'oDB0bs' % Online DBN: see dyn bayes net, using soft evidence
        %             'oDB0bsV'% Online DBN: see dyn bayes net, using soft evidence, with Validation
        };
    
end

for i=1:length(labelName)
    fprintf('Model: %s\n',labelName{i});
    eval(['[gameScoresP' labelName{i} ' gameScoresObj' labelName{i} ' predictedP' labelName{i} ' predictedObj' labelName{i} '  eyePositions scoresMeanAUC' labelName{i} '   R' labelName{i} ']   = modelBaseClassifierAll(gameNo, theMap, eyePos, objTagData, labelName{i});'])
    if isOnline; onlineName = 'online'; else onlineName = 'offline'; end;
    save(['./data/Result_G' num2str(gameNo) '_sacc_' onlineName '_' labelName{i} '.mat'],['gameScoresP' labelName{i}] , ['gameScoresObj' labelName{i}], ['predictedP' labelName{i}],['predictedObj' labelName{i}],['scoresMeanAUC' labelName{i}] ,['R' labelName{i}]);
end

